using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using EPSCOMLib;

namespace EPS2Lenses
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private EPSLens lens1;
		private EPSLens lens2;
		private EPSLensRegion region1;
		private EPSLensRegion region2;
		private EPSEnvironment env;
		private EPSVec2 vecIn1 = new EPSVec2Class();
		private EPSVec2 vecOut1 = new EPSVec2Class();
		private EPSVec2 vecIn2 = new EPSVec2Class();
		private EPSVec2 vecOut2 = new EPSVec2Class();
		private Graphics gc;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(528, 502);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			this.pictureBox1.Paint += new System.Windows.Forms.PaintEventHandler(this.pictureBox1_Paint);
			this.pictureBox1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseMove);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(528, 502);
			this.Controls.Add(this.pictureBox1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		//Initialize EPS so it has a Lens of a particular style
		private void SetupEPS () 
		{
			// Create a new lenses 
			lens1 = new EPSLensClass();      
			lens1.RemoveAllRegions();    
			lens2 = new EPSLensClass();      
			lens2.RemoveAllRegions();    

			// Create a region and add it to the lens
			region1 = new EPSLensRegionClass();  
			lens1.AddRegion(region1);
			region2 = new EPSLensRegionClass();  
			lens2.AddRegion(region2);

			// Create an environment and add lenses to it
			env = new EPSEnvironmentClass();
			env.AddLens(lens1);
			env.AddLens(lens2);			
		}

		// Convert a vector into an integer point
		private Point V2pt (EPSVec2 vector)
		{
			return (new Point ( (int) vector.x , (int) vector.y) );
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.SetupEPS();
		}

		private void pictureBox1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			int gridsize = 50;
			gc = e.Graphics;
			int xincr = pictureBox1.Width / gridsize;
			int yincr = pictureBox1.Height / gridsize;
			int lastx = 0;

			for (int y = 0; y <= pictureBox1.Height; y += yincr ) 
			{
				for (int x = 0; x <= pictureBox1.Width; x += xincr ) 
				{
					vecIn1.set(lastx,y);
					vecIn2.set(x,y);

					// use the method in env to calculate the output
					env.get_MagnifiedPoint2DandMagnification(vecIn1, vecOut1);

					Point p1 = V2pt (vecOut1);
					p1.Offset (-1, -1);
					gc.DrawRectangle (Pens.Red, p1.X, p1.Y, 2,2);

					lastx = x;
				}
				lastx = 0;
			}


		}

		private void pictureBox1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Left)
			{
				EPSVec2 focalCenter = new EPSVec2Class();
				focalCenter.set(e.X, e.Y);
				lens1.Center = focalCenter;
				pictureBox1.Invalidate ();
			}
			else if (e.Button == MouseButtons.Right)
			{
				EPSVec2 focalCenter = new EPSVec2Class();
				focalCenter.set(e.X, e.Y);
				lens2.Center = focalCenter;
				pictureBox1.Invalidate ();
			}
			else
				return;

		}

	}
}
